<script>
  import { onMount, onDestroy } from 'svelte'
  import Panzoom from '@panzoom/panzoom'

  import {
    ArrowBack,
    ArrowForward,
    Close,
    ZoomIn,
    ZoomOut,
  } from '../assets/icons'

  import LoadingBox from '../components/LoadingBox'
  import Error from '../components/Error'
  import ModalSimple from '../components/ModalSimple'

  import { setToast, store as toastStore } from '../stores/toast'

  import {
    getHomeworkResources,
    deleteHomeworkResource,
  } from '../api/homeworkResources'
  import homeworkResources from '../stores/homeworkResources'
  import getGroupAuth from '../utils/getGroupAuth'
  import getImageUrls from '../utils/getImageUrls'
  import { downloadImagesIntoCache } from '../utils/offlineUtils'

  export let route
  $: groupId = parseInt(route.matches[1])
  $: homeworkId = parseInt(route.matches[2])
  $: index = route.matches[3] && parseInt(route.matches[4])

  $: resources = $homeworkResources[homeworkId]
  $: imageUrls = resources && getImageUrls(resources)

  $: downloadImagesIntoCache(imageUrls)

  // Date formatting
  const dateFormatter = new Intl.DateTimeFormat('es', {
    year: 'numeric',
    month: 'numeric',
    day: 'numeric',
  })
  const timeFormatter = new Intl.DateTimeFormat('es', {
    hour: 'numeric',
    minute: 'numeric',
  })
  $: formattedDates =
    resources &&
    resources.map(({ created_at }) => {
      const dateObj = new Date(created_at)
      const date = dateFormatter.format(dateObj)
      const time = timeFormatter.format(dateObj)
      return `subida el ${date} a las ${time}`
    })

  // API Fetching
  let error
  function refresh() {
    error = null
    getGroupAuth(groupId)
      .then(auth => getHomeworkResources(homeworkId, auth))
      .catch(e => (error = e))
  }
  $: refresh(homeworkId)

  // Modal confirmation for deleting resource
  let resourceIdToDelete = null
  let deletingResource = false

  function closeToast() {
    resourceIdToDelete = null
    deletingResource = false
  }

  // Resource deleting
  function deleteResource(id) {
    deletingResource = true
    return getGroupAuth(groupId)
      .then(auth => deleteHomeworkResource(id, auth))
      .then(() => {
        setToast('Ese recurso fue borrado.')
      })
      .catch(error => {
        setToast('Hubo un problema borrando ese recurso.')
        console.error(error)
      })
      .finally(() => closeToast())
  }

  // Scrolling to position
  let modalEl
  const scrollTo = (nextIndex = index) => {
    modalEl && modalEl.scrollTo(nextIndex * window.screen.width, 0)
  }
  onMount(scrollTo) // hook to onMount, when modalEl becomes available
  $: scrollTo(index) // if route changes

  // Zooming properly
  let resourceEls = []
  let panzooms = []
  const destroyPanzooms = () => panzooms.forEach(p => p.destroy())
  const panzoomOptions = {
    minScale: 0.5,
  }
  const setupZoom = () => {
    destroyPanzooms()
    panzooms = resourceEls.map(el => {
      const panzoom = new Panzoom(el)
      el.parentElement.addEventListener('wheel', e => {
        if (!e.shiftKey) return
        panzoom.zoomWithWheel(e)
      })
      return panzoom
    })
  }
  onMount(setupZoom)

  const zoom = (index, diff) => {
    const panzoom = panzooms[index]
    panzoom.zoom(panzoom.getScale() + diff)
  }
  // clean up
  onDestroy(destroyPanzooms)

  //$: setupZoom(resourceEls)
</script>

{#if resourceIdToDelete !== null}
  <ModalSimple className="z-35" closeFn={closeToast}>
    <h3 class="text-xl text-center">
      ¿Estás segurx de que querés borrar este recurso?
    </h3>
    <div class="mx-auto mt-2 text-center">
      <button
        class="btn btn-red mx-auto mb-1"
        on:click={deleteResource(resourceIdToDelete)}
        disabled={deletingResource}
      >
        Borrar recurso permanentemente
      </button>
      <button
        class="btn btn-outlined mx-auto mb-1"
        on:click={closeToast}
        disabled={deletingResource}
      >
        Cancelar
      </button>
    </div>
  </ModalSimple>
{/if}

<!-- the "class:pb-8" is a hacky way to make toasts show properly -->
<div
  class="modal bg-black text-white flex overflow-x-auto scroll-snap-x"
  class:pb-8={$toastStore}
  bind:this={modalEl}
  on:click={e => route.backCb(route)}
>
  {#if error}
    <div class="flex mx-auto p-2">
      <div class="m-auto max-w-lg">
        <Error {error} />
        <button
          class="btn btn-blue m-2 block mx-auto"
          on:click={() => route.backCb(route)}
        >
          Volver al grupo
        </button>
      </div>
    </div>
  {:else if resources}
    {#if resources.length < 1}
      <div class="flex mx-auto p-2">
        <div class="m-auto max-w-lg">
          <p class="text-center">Esta tarea no tiene recursos.</p>
          <button
            class="btn btn-blue m-2 block mx-auto"
            on:click={() => route.backCb(route)}
          >
            Volver al grupo
          </button>
        </div>
      </div>
    {/if}
    {#each resources as resource, index}
      <div
        class="flex flex-col min-w-full max-w-full scroll-snap-start
        scroll-snap-stop force-touch-pan"
      >
        <div class="flex bg-smoke text-white z-40">
          <button
            class="s-12 p-1"
            aria-label={'volver al grupo'}
            on:click|stopPropagation={() => route.backCb(route)}
          >
            <Close props={{ class: 'h-full', 'aria-hidden': true }} />
          </button>
          <div class="w-full" />
          <button
            class="s-12 p-2"
            aria-label={'subir zoom'}
            on:click|stopPropagation={() => zoom(index, 0.4)}
          >
            <ZoomIn
              props={{ class: 'h-full', 'aria-hidden': true, width: null, height: null }}
            />
          </button>
          <button
            class="s-12 p-2"
            aria-label={'bajar zoom'}
            on:click|stopPropagation={() => zoom(index, -0.4)}
          >
            <ZoomOut
              props={{ class: 'h-full', 'aria-hidden': true, width: null, height: null }}
            />
          </button>
        </div>
        <img
          src={imageUrls[index]}
          class="m-auto force-touch-pan flex-grow object-contain min-h-0"
          bind:this={resourceEls[index]}
          on:click|stopPropagation={e => false}
        />
        <div class="nav flex bg-smoke z-40 items-center">
          <button
            class="s-12 p-1"
            aria-label={'ir a la imágen anterior'}
            on:click|stopPropagation={() => scrollTo(--index)}
          >
            <ArrowBack props={{ class: 'h-full', 'aria-hidden': true }} />
          </button>
          <p class="text-center w-full">
            {formattedDates[index]}
            <button
              class="btn ml-1 px-2 py-1 btn-outlined bg-transparent"
              on:click|stopPropagation={e => (resourceIdToDelete = resource.id)}
            >
              Borrar
            </button>
          </p>
          <button
            class="s-12 p-1"
            aria-label={'ir a la imágen siguiente'}
            on:click|stopPropagation={() => scrollTo(++index)}
          >
            <ArrowForward props={{ class: 'h-full', 'aria-hidden': true }} />
          </button>
        </div>
      </div>
    {/each}
  {:else}
    <LoadingBox />
  {/if}
</div>

<style>
  .force-touch-pan {
    touch-action: pan-x !important;
  }
</style>
